SystemOrganization addCategory: #ConfigurationOftODE!

Object subclass: #ConfigurationOftODE
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOftODE'!

!ConfigurationOftODE class methodsFor: 'development support' stamp: 'dkh 5/22/2011 12:40'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOftODE class methodsFor: 'private' stamp: 'dkh 5/22/2011 12:40'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOftODE class methodsFor: 'private' stamp: 'dkh 5/22/2011 12:40'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOftODE class methodsFor: 'private' stamp: 'dkh 5/22/2011 12:40'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOftODE class methodsFor: 'metacello tool support' stamp: 'dkh 5/22/2011 12:40'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOftODE class methodsFor: 'loading' stamp: 'dkh 5/22/2011 12:40'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOftODE class methodsFor: 'loading' stamp: 'dkh 5/22/2011 12:40'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOftODE class methodsFor: 'loading' stamp: 'dkh 5/22/2011 12:40'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOftODE class methodsFor: 'accessing' stamp: 'dkh 5/22/2011 12:40'!
project

	^self new project! !

!ConfigurationOftODE class methodsFor: 'development support' stamp: 'dkh 5/22/2011 12:40'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOftODE methodsFor: 'baselines' stamp: 'dkh 10/5/2011 17:14'!
baseline01: spec
	<version: '0.1-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://ss3.gemstone.com/ss/tODE'.
		spec 
			project: 'Bibliocello' with: [
				spec
					className: 'ConfigurationOfBibliocello';
					versionString: #'development';
					loads: #('Bibliocello-Parser' );
					repository: 'http://seaside.gemstone.com/ss/bibliocello' ];
			project: 'Kaliningrad' with: [
				spec
					className: 'ConfigurationOfKaliningrad';
					versionString: #'development';
					repository: 'http://ss3.gemstone.com/ss/Kaliningrad' ];
			project: 'Seaside30' with: [
				spec
					className: 'ConfigurationOfSeaside30';
					versionString: #'stable';
					loads: #('Base' 'JQuery-UI' );
					repository: 'http://www.squeaksource.com/Seaside30' ];
			project: 'SeasideJSON' with: [
				spec
					className: 'ConfigurationOfSeasideJSON';
					versionString: #'bleedingEdge';
					repository: 'http://www.squeaksource.com/MetacelloRepository' ];
			project: 'JQueryWidgetBox' with: [
				spec
					className: 'ConfigurationOfJQueryWidgetBox';
					versionString: #'bleedingEdge';
					loads: #('JQWidgetBox-UILayout-Core' 'JQWidgetBox-Splitter-Core' );
					repository: 'http://www.squeaksource.com/JQueryWidgetBox' ];
			project: 'MetacelloBrowser' with: [
				spec
					className: 'ConfigurationOfMetacelloBrowser';
					versionString: #'stable';
					loads: #('Core' );
					repository: 'http://www.squeaksource.com/MetacelloBrowser' ].
		spec 
			package: 'tODE-Amber' with: [
				spec requires: #('tODE-Core' 'Seaside30' 'JQueryWidgetBox' 'tODE-AmberClient' 'SeasideJSON'). ];
			package: 'tODE-AmberClient' with: [
				spec requires: #('Kaliningrad' ). ];
			package: 'tODE-Bibliocello' with: [
				spec requires: #('tODE-Core' 'Bibliocello' ). ];
			package: 'tODE-Core' with: [
				spec includes: #('tODE-Seaside' ). ];
			package: 'tODE-Code' with: [
				spec requires: #('tODE-Bibliocello' 'tODE-Views' 'tODE-Search' ). ];
			package: 'tODE-Debugger' with: [
				spec requires: #('tODE-Inspector' ). ];
			package: 'tODE-Help' with: [
				spec requires: #('tODE-Views' ). ];
			package: 'tODE-Inspector' with: [
				spec requires: #('tODE-Views' ). ];
			package: 'tODE-Metacello' with: [
				spec requires: #('tODE-Views' 'tODE-Search' 'MetacelloBrowser' ). ];
			package: 'tODE-Search' with: [
				spec requires: #('tODE-Views' ). ];
			package: 'tODE-Seaside' with: [
				spec requires: #('tODE-Core' 'Seaside30' 'JQueryWidgetBox' ). ];
			package: 'tODE-TestCase' with: [
				spec requires: #('tODE-Views' ). ];
			package: 'tODE-Views' with: [
				spec requires: #('tODE-Core' ). ];
			package: 'tODE-Workspace' with: [
				spec requires: #('tODE-Views' ). ];
			package: 'tODE-Tests-Core' with: [
				spec requires: #('tODE-Core' ). ]. ].

	spec for: #'pharo' do: [
		spec 
			package: 'tODE-Code' with: [
				spec includes: #('tODE-Pharo-Code' ). ];
			package: 'tODE-Core' with: [
				spec includes: #('tODE-Pharo-Core' ). ];
			package: 'tODE-Debugger' with: [
				spec includes: #('tODE-Pharo-Debugger' ). ];
			package: 'tODE-Inspector' with: [
				spec includes: #('tODE-Pharo-Inspector' ). ];
			package: 'tODE-Metacello' with: [
				spec includes: #('tODE-Pharo-Metacello' ). ];
			package: 'tODE-Search' with: [
				spec includes: #('tODE-Pharo-Search' ). ];
			package: 'tODE-Seaside' with: [
				spec includes: #('tODE-Pharo-Seaside' ). ];
			package: 'tODE-Views' with: [
				spec includes: #('tODE-Pharo-Views' ). ];
			package: 'tODE-Workspace' with: [
				spec includes: #('tODE-Pharo-Workspace' ). ];
			package: 'tODE-Pharo-Code' with: [
				spec requires: #('tODE-Code' ). ];
			package: 'tODE-Pharo-Core' with: [
				spec requires: #('tODE-Core' ). ];
			package: 'tODE-Pharo-Debugger' with: [
				spec requires: #('tODE-Debugger' ). ];
			package: 'tODE-Pharo-Inspector' with: [
				spec requires: #('tODE-Inspector' ). ];
			package: 'tODE-Pharo-Metacello' with: [
				spec requires: #('tODE-Metacello' ). ];
			package: 'tODE-Pharo-Search' with: [
				spec requires: #('tODE-Search' ). ];
			package: 'tODE-Pharo-Seaside' with: [
				spec requires: #('tODE-Seaside' ). ];
			package: 'tODE-Pharo-Views' with: [
				spec requires: #('tODE-Views' ). ];
			package: 'tODE-Pharo-Workspace' with: [
				spec requires: #('tODE-Workspace' ). ]. ].

	spec for: #'gemstone' do: [
		spec 
			project: 'GsPharo' with: [
				spec
					className: 'ConfigurationOfGsPharo';
					versionString: #'development';
					repository: 'http://seaside.gemstone.com/ss/PharoCompat' ];
			project: 'WAObjectLogTable' copyFrom: 'Seaside30' with: [
				spec loads: #('Seaside-GemStone-Tools-Production' ) ];
			project: 'JQGrid' copyFrom: 'JQueryWidgetBox' with: [
				spec loads: #('JQWidgetBox-JQGrid-Core' ) ].
		spec 
			package: 'tODE-Code' with: [
				spec includes: #('tODE-GemStone-Code' ). ];
			package: 'tODE-Core' with: [
				spec includes: #('tODE-GemStone-Core' ). ];
			package: 'tODE-Debugger' with: [
				spec includes: #('tODE-GemStone-Debugger' ). ];
			package: 'tODE-Inspector' with: [
				spec includes: #('tODE-GemStone-Inspector' ). ];
			package: 'tODE-Search' with: [
				spec includes: #('tODE-GemStone-Search' ). ];
			package: 'tODE-Seaside' with: [
				spec includes: #('tODE-GemStone-Seaside' ). ];
			package: 'tODE-Views' with: [
				spec includes: #('tODE-GemStone-Views' ). ];
			package: 'tODE-GemStone-Code' with: [
				spec requires: #('tODE-Code' ). ];
			package: 'tODE-GemStone-Core' with: [
				spec requires: #('tODE-Core' ). ];
			package: 'tODE-GemStone-Debugger' with: [
				spec requires: #('tODE-Debugger' ). ];
			package: 'tODE-GemStone-Inspector' with: [
				spec requires: #('tODE-Inspector' ). ];
			package: 'tODE-GemStone-Search' with: [
				spec requires: #('tODE-Seaside' ). ];
			package: 'tODE-GemStone-Seaside' with: [
				spec requires: #('tODE-Search' ). ];
			package: 'tODE-GemStone-Views' with: [
				spec requires: #('tODE-Views' ). ];
			package: 'tODE-GemTools' with: [
				spec requires: #('tODE-Inspector' 'WAObjectLogTable' 'JQGrid' ). ]. ].

	spec for: #'gs2.x' do: [
		spec 
			package: 'tODE-GemStone-Code' with: [
				spec includes: #('tODE-GemStone-240-Code' ). ];
			package: 'tODE-GemStone-Inspector' with: [
				spec includes: #('tODE-GemStone-240-Inspector' ). ];
			package: 'tODE-GemStone-240-Code' with: [
				spec requires: #('tODE-GemStone-Code' ). ];
			package: 'tODE-GemStone-240-Inspector' with: [
				spec requires: #('tODE-GemStone-Inspector' ). ]. ].

	spec for: #'gs3.x' do: [
		spec 
			package: 'tODE-GemStone-Code' with: [
				spec includes: #('tODE-GemStone-300-Code' ). ];
			package: 'tODE-GemStone-Inspector' with: [
				spec includes: #('tODE-GemStone-300-Inspector' ). ];
			package: 'tODE-GemStone-300-Code' with: [
				spec requires: #('tODE-GemStone-Code' ). ];
			package: 'tODE-GemStone-300-Inspector' with: [
				spec requires: #('tODE-GemStone-Inspector' ). ]. ].
! !

!ConfigurationOftODE methodsFor: 'symbolic versions' stamp: 'dkh 5/22/2011 12:40'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: '0.1'.
! !

!ConfigurationOftODE methodsFor: 'accessing' stamp: 'dkh 5/22/2011 12:40'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOftODE methodsFor: 'versions' stamp: 'dkh 10/17/2011 20:33'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline' )>

	spec for: #'common' do: [
		spec blessing: #'development'.
		spec description: '- checkpoint ... fleshing out the inspector
- KISSing
- get selected center tab indx logic straightened out
- add frame link to basic inspector view for an object
- inverse frame lookup to reuse frame state and object state
- eliminate frameIndex
0.1 (dkh.7):
- rearrange inspector pane
0.1 (dkh.8):
- getting started on tODE class browser
- tweak inspector
0.1 (dkh.9):
- tweaks
0.1 (dkh.10):
- TOTabSpec keeps the receiver and frame state itself
- added frame tab for inspecting the tODE subsystem
- added explorer view for class tab ... 
0.1 (dkh.11):
- in class explorer, clicking on class should browse refs, like the instance variables ...
0.1 (dkh.12):
- get started on method browser
0.1 (dkh.13):
- change the default application path...
0.1 (dkh.14):
- basic method viewing is implemented ...
0.1 (dkh.15):
- superclass navigation and method browser
0.1 (dkh.16):
- use accordion for method categories in sidebar
0.1 (dkh.17):
- class hierarchy sidebar
0.1 (dkh.18):
- first cut at sanitization in prep for GemStone port
0.1 (dkh.19):
- starting GemStone port
0.1 (dlh.20):
- continued gemstone port
- start adding workspace
0.1 (dkh.21):
- basic port to GemStone complete
0.1 (dkh.24):
- getting TOWorkspace view working ... todo: doit/inspecit
0.1 (dkh.25):
- worksapce is basically working now (safari and chrome)
0.1 (dkh.26):
- use buttons for certain links...
0.1 (dkh.27):
- navigation buttons
0.1 (dkh.28):
- straighten out the inspector ...
0.1 (dkh.29):
- add doit button to workspace 
- push:selecting: propogation
0.1 (dkh.30):
- send message button 
- bookmark button
- extra content ... select: function on collections
0.1 (dkh.31):
- getting started on error hanlding for expression evaluation
0.1 (dkh.32):
- progress on debugger
0.1 (dkh.33):
- debugger/inspector is coming together
0.1 (dkh.34):
- seaside error handlers call TODebugger
0.1 (dkh.35):
- big refactoring ... specifiy the rendererClass (view class) in the tabSpec and make it possible to access renderer independent of rendering ... to set state for example prior to rendering,,,
0.1 (dkh.36):
- tweak
0.1 (dkh.37):
- bookmarks implemented ... first cut
0.1 (dkh.38):
- start work on test case tab 
0.1 (dkh.38):
- hook up debugger to test runner
- fix test
0.1 (dhk.40):
- misc stuff
- start on search page
0.1 (dkh.41):
- search basics complete
- bare minimum for debugging errors during rendering phase
0.1 (dkh.42):
- save/cancel for mthod editor
0.1 (dkh.43):
- save buttons for class browser
0.1 (dkh.44):
- major repackaging
0.1 (dkh.45):
- STARTED DOING DEVELOPMENT IN tODE
- search button for search
- starting to add method category control ...
0.1 (dkh.46):
- method categorization
0.1 (dkh.47):
- getting started on Metacello tab
0.1 (dkh.48):
- missed pharo-specific search code
0.1 (dkh.51):
- bare minimum of functionality in gemstone
0.1 (dkh.52):
- a little bit of gardening
0.1 (dkh.53):
- preserve bookmarks across reset
- platform-specific window title
- metaclass navigation
0.1 (dkh.54):
- improve gemstone method implementors speed
- include space in tODE frame
0.1 (dkh.55):
- initial bookmarks defined by pragmas..
0.1 (dkh.56):
- fiddle with bookmarks
tweaks
0.1 (dkh.58):
- major refactoring: 
    TOSpace renamed to TOSession
    TOSystem added (to permit cross-namespace development)

0.1 (dkh.59):
- infant mortality after refactoring ... 
0.1 (dkh.60):
- finally got debug window to display only in workspace inspect contents but it is a start
0.1 (dkh.61):
- looks like I''ve got basic error handling solved (for pharo):
  TOException pushed on stack
  internal server error response
  javascript error handler in client that refreshes the view so that the TOException is visible
0.1 (dkh.62):
- integrate gemstone-specific changes needed since 0.1 (dkh.58)
0.1 (dkh.63):
- debugger is basically working in GemStone now!!
0.1 (dkh.64):
- gardening
- set error handler for tODE to TOSeasideErrorHandler, so that tODE can be used in production
0.1 (dkh.65):
- gear up for platform-specific home page
- get started on GemStone home page
0.1 (dkh.66):
- start works on GemTools home
0.1 (dkh.70):
- object log view is functional ...
0.1 (dkh.71):
- reversed transcript order
0.1 (dkh.72):
- add inspection link to object log view
- object log and continuation (gsprocess) inspector views
- refactor TODebugger hierarchy
- all pretty much GemStone-only work 
0.1 (dkh.73):
- tweak object log display
0.1 (dkh.74):
- tweak basic inspector view
- start metacello support again ... 
  - revert package command 
  - browse class ... wan that to be better
0.1 (dkh.75):
- more work on metacello view ...
0.1 (dkh.76):
- more metacello work ...
0.1 (dkh.77):
- pragma-based search categories
- more metacello pane work
0.1 (dkh.78):
- add view tab
- gardening
- major metacello refactoring
0.1 (dkh.79):
- add ''package changes'' metacello command
0.1 (dkh.80):
- support for multiple sessions
0.1 (dkh.81):
- multiple session support
- remove method command and clean up method browsing a bit
- start work on MCWorkingCopy view
0.1 (dkh.82):
- note to self
0.1 (dkh.83):
- select method and category from MethodReferece
- add autocomplete in text area for previous expressions typed
- improve ''new session'' logic ... numbered sessions
0.1 (dkh.84):
- simplified view tab logic
- trying to get ''west'' size and preserve across component instances
0.1 (dkh.85):
- Configurations displayed on home view ... when Metacello loaded
0.1 (dkh.86):
- RESET root refreshing whole display
- save method doesn''t update selected method in sidebar
- exact senders/implementors 
- expression list reversed

0.1 (dkh.87):
- infant mortality for exact senders/implementors
- current session stashed with Seaside session ... error handler fixed.
0.1 (dkh.88):
- TOStackFrame method context links to instance method source/class browser
0.1 (dkh.89):
- navigation from mcpatch operations
0.1 (dkh.90):
- package history command
- TOCollection and TOItemView as alternative browsing strategy
- tODE project link on home page
- reordered home page
- fix search bug
- tweak west frame size
0.1 (dkh.91):
- TOCollection used for search results (class and methods) ... configs are okay, but workingCopy view tab needs to be defined
- selected item highlighted in TOCollection
- improved TOCollection navigation
- a couple of minor bugfixes
0.1 (dkh.92):
- use TOCollection for class explorer
0.1 (dkh.92):
- bring in Bibliocello-Core for GemStone/Pharo parsing/formatting/method explorer support
- add format button to method browser
- use SourcedMethodReference instead of MethodReference ... not portable to GemStone ... later
0.1 (dkh.94):
- syntax highlighting for the method explorer
0.1 (dkh.95):
- senders links addd to syntax highlighting vew ... 
0.1 (dkh.96):
- syntax highlighting work with links

0.1 (dkh.97):
- fix problem with nested selector/global links
0.1 (dkh.98):
- fix the line length problem for styled method source
0.1 (dkh.99):
- starting on load configuration command
0.1 (dkh.100):
- ''load configuration'' command implemented
- picked up checkbox trick from james
0.1 (dkh.101):
- tweaked the load command ...
0.1 (dkh.102):
- add configuration command getting fleshed out ...
0.1 (dkh.103):
- scattered bugfixes
- introduce frame titles
- introduce TOLinkedView (an alternate navigations scheme to TOItemView for TOCollection)
- add package changes command for configuration
0.1 (dkh.104):
- attempting to highlight compile errors...
0.1 (dkh.105):
- get selection of syntax error working
0.1 (dkh.106):
- compiler error handling improved
- red dot shows up on error
0.1 (dkh.107):
- tweaked the formatter
0.1 (dkh.108):
- highlight compile errors
- remove session command
- tweak error handling and highlight pc when available
- a little gardening
- push current object for new session

0.1 (dkh.109):
- more work on metacello browser ...
0.1 (dkh.110):
- metacello refactoring 
- add stubs for add package and add class commands ... help to focus thoughts on where functiona are supposed to go
- infant mortality on compile/parse errors/notifications
0.1 (dkh.111):
- work on straightening out syntax/compile errors for workspaces and doit:/inspectit ..
0.1 (dkh.112):
- displaying the structure of versions ... metacello browser continued
0.1 (dkh.113):
- pused version views to sidebar
- moved some classes from core to view (where they belong)
0.1 (dkh.114):
- improve formatting for version view
0.1 (dkh.115):
- format tweaks 
0.1 (dkh.116):
- arrange for resuming exceptions from debugger ... seaside debugging is a bit rough when the debugged seaside component is expected to continue with it''s stuff, since tODE interferes. 
- debugging tODE doits is working 
0.1 (dkh.117):
- project specs rendered
- remove/copy/add/merge operation displayed
- username and password for repository entry
0.1 (dkh.118):
- checkpoint .. in midst of introducing path into version display ...
0.1 (dkh.119):
- checkpoint ... further path work
0.1 (dkh.120):
- more path work ... using selected path as filter ... work in progress
0.1 (dkh.121):
- continued work on version spec editing .... aka metacello browser
0.1 (dkh.122):
- highlight instead of filter for selected components in version editor
0.1 (dkh.123):
- project load list editor
0.1 (dkh.124):
- loads and repositories editted as part of their parent spec instead of separately
0.1 (dkh.125):
- fixed infant moratlity bugs with recent refactoring ... all projects are displaying correctly
0.1 (dkh.126):
- package editor
- group editor 
- version display is pretty much done ... now for the actual editing
0.1 (dkh.127):
- new repository command added ... autocomplete kinks need to be worked out
0.1 (dkh.128):
- get new repository working...
0.1 (dkh.129):
- getting started on add project command
0.1 (dkh.130):
- tweaks
- refactorings
- fill out the project/package/group edit functions
0.1 (dkh.131):
- history uses the same labeling scheme as the frame title
- tweaks
- archive version command plus big reorg
- add version command
0.1 (dkh.132):
- copy class command
- TOCollection>>select:
- tweaks
- save package, checkpoint config, version creation commands
- package tab and configuration tab filled out with most commands
- improved error handling
0.1 (dkh.133):
- move some methods into MetacelloBrowser package
- pick up MetacelloBrowser 1.61 and Metacello 1.0-beta.30 (with tODE support)
- tweak add version commands
- add remove version command
- additional tweaks
0.1 (dkh.134):
- porting to GemStone ... mispackaged Pharo class references
0.1 (dkh.135):
- after Bibliocello repackaging, require only the Bibliocello parser for formatting, etc.
- add compensation for  GemStone Issue 221 (http://code.google.com/p/glassdb/issues/detail?id=221)
- tweak UI in several places (reduce clicks needed to navigate)
- repackage some methods from platform-specific to shared 
- make subclassing TOHome easier
- finish up the port to GemStone 2.4.x
- add self, class and oop synthetic fields to inspector
- lots of "MetacelloBrowser" tweaks
0.1 (dkh.136):
- TOCollection must be subclass of TORenderer, not TOView ... in the fullness of time, TOView might just disappear...
0.1 (dkh.139):
- port GemStone changes back to Pharo
- fix a typo
0.1 (dkh.140):
- string search is platform specific
- use JQueryWidgetBox 2.4 (minimal Seaside30 requirements)
0.1 (dkh.141):
- allow configuration branches to be used in a project reference (className: is name sans branch, file: is name with branch) [Metacello 1.0-beta.30]
- use ConfigurationOfJQueryWidgetBox.cleanup branch configuration until my changes are integrated into the mainline
0.1 (dkh.143):
- replace references to MBToolBox with MetacelloToolBox
0.1 (dkh.144):
- resolve some sent but not implemented issues
0.1 (dkh.145):
- dump stack to log file when snapping off a continuation
0.1 (dkh.146):
- add validate command
- fix configuration history command
0.1 (dkh.147):
- put stone name in the g/s tODE tab
0.1 (dkh.148):
- load version command
- tweaks
0.1 (dkh.149):
- image name in windowTitle for Pharo
- windowTitle in tab and in the page title too
0.1 (dkh.150):
- add ''Update Dev'' command ... now know as ''upgrade <version string>''
0.1 (dkh.151):
- add ''reset configuration root'' button to standard home page .... until we get the update logic straightened out
0.1 (dkh.152):
- removed ''reset config root'' command from GemStone Tools section ... not platform specific anymore
0.1 (dkh.153):
- TOObject>>deploy: is needed to set autoMigrate and autoCommit when doing loads or class shape modifications so that migrations and almostOutOfMemory situations can be averted ... 
0.1 (dkh.154):
- fix upgrade version to avoid non-local block returns
0.1 (dkh.155):
- pick up Pharo version of TOObject>>deploy:
0.1 (dkh.156):
- use Behavior>>methodsDo: for GemStone 3.0.0 compatibility
0.1 (dkh.157):
- TOMethodSourceBrowser>>accept: is dependent upon which version of GemStone you are running (2.4 vs 3.0)
0.1 (dkh.158):
- display userId in title ... GemStone only
0.1 (dkh.160):
- use trunk version of JQueryWidgetBox (no longer use cleanup branch  as that branch integrated into trunk)
0.1 (dkh.161):
- TOObject>>renderIntraPageLink:with:on: so that intra page navigation (same object) can be differentiated object to object navigation ... 
0.1 (dkh.163):
- presentation tweaks
- minor bugfixes
- clean up package/configuration creation
- remove ''version'' tab (for now) ... package and configuration seem to be enough
- TOSeasideSession and TOSeasideCache added to obviate need to mtce vm for Cloud Foundry demo
- WAComponent ''help'' tab includes references to http://book.seaside.st
- WAComponent ''view'' opens component in its own tab...
0.1 (dkh.164):
- pick up pharo changes for tweaks
0.1 (dkh.165):
- ExpiryPolicy class for TOSession is platform specific
0.1 (dkh.166):
- clean up some GemStone-specific code
0.1 (dkh.167):
- pick up Pharo variant
0.1 (dkh.168):
- fix bug in unload configuration
- create project command includes way to specify configuration repository
0.1 (dkh.169):
- system status display in navigation bar
- use Seaside 3.0.5.0.1
0.1 (dkh.170):
- tweaks for running in Pharo1.3
0.1 (DataCurator.171):
- replace TOSession>>home with TOSession>>pushHome ... better name, less confusing
0.1 (dkh.175):
- taking a different approach to handling tests
0.1 (dkh.176):
- minor cleanup
0.1 (dkh.177):
- starting an experiment where I''m eliminating the sidebar and allowing for frames to be moved to sidebar ...
0.1 (dkh.178):
- changes for Amber compatibility in tODE-Core
0.1 (dkh.179):
- beginning of port to Amber ... pulled classes from Kaliningrad and renamed them
- Kaliningrad is supplying the Amber brower (until tODE is functional) and source management (save Amber code to WAFileLibrary instances)
- Seaside-JSON is used for pass state/callbacks from server to Amber
0.1 (dkh.180):
- pick up the Amber code that supports tODE and examples
- change the counter to match the most recent updates from Philippe
0.1 (dkh.181):
- fix required scripts for TOAmberMain
0.1 (dkh.182):
- initialize KOAmberBrowser with ''tODEAmber.js'' reference until tODE becomes a viable editor for Amber
0.1 (dkh.183):
- a little house cleaning with class renaming in amber 
- start RESTful journey by pulling the home object over from server .... client is not supposed to make assumptions about the server data, which is actually right in the wheel house for tODE ... will see where I end up ...
0.1 (dkh.184):
- TOFrame is url-based instead of object-based. Url is resolved whenever the frame is accessed to provide fresh state for the referenced object
- AJAX request to access the Url schedules the rendering ... which is all we are doing on the client ... at least for now ...
- server provides a renderBlock that contains the rendering code used by the client-side to render the frame...
- see how far I can go with this...
0.1 (dkh.185):
- arranged to move from one frame to another on button press ...
- rendering code and state supplied by server, client is managing frames (that reference an URL and compile the rendering code on demand) ...
- falling into place
0.1 (dkh.186):
- add TOComponent and TOStandardComponent to manage the rendering of JSON for Amber tODE
0.1 (dkh.187):
- add TOAmberComponent and TOAmberHomeComponent to replace TOComponent, TOStandardComponent and TOAmberRestfulHandler (removed). I needed callbacks for the object references in the inspector, so needed a Seaside component...
- add center frame header ...
- inspector is working just fine....
0.1 (dkh.188):
- add session tabs to Amber-based tODE
0.1 (dkh.189):
- use the title of the current object as the title in the session tab
0.1 (dkh.190):
- basic navigation functional
- session tabs functional
0.1 (dkh.191):
- clean up amber-side code a bit
0.1 (dkh.192):
0.1 (dkh.193):
- figured out how to make tabs() jquery call from smalltalk ... checkpoint
0.1 (dkh.194):
- get list of tabs from the currentFrame
- hook into tab selection event and set tab ...
- need to chenge refesh logic so tab list is refreshed correctly (on session select for sure  ... needed on every #update?
0.1 (dkh.195):
- properly display and select tabs when switching between sessions
0.1 (dkh.196):
- go with a frame component that describes frame contents ... only include the json for the selected tab which should be a field on the url...then have separate renderers that produce the JSON and Amber renderBlock ... can adapt this to existing structure that uses pragmas in Pharo and GemStone ...

0.1 (dkh.197):
- honing style of center pane ...
0.1 (dkh.198):
- fiddle a bit to get scrolling and tab selection to work together
0.1 (dkh.199):
- line wrap horizontally ... scroll would be nice but linewrap is convenient too...
0.1 (dkh.200):
- renamed Amber tODE classes so that they won''t collide with Pharo tODE classes
- renamed package, too
- added tODE-AmberClient package to contain the Amber tODE classes
0.1 (dkh.201):
- finish up the Amber class/package renaming effort
0.1 (dkh.202):
- expression evaluation is enabled ...
0.1 (dkh.204):
- start work on debugger ... step 1 exception handler
0.1 (dkh.205):
- minor push towards debugger
0.1 (dkh.206):
- a couple of tweaks to error handlers to reflect most recent changes to gemstone handlers and TOSeasidehandler should not be the default seaside handler ... only error handler for tODE
0.1 (dkh.207):
- amber tode converted to use accordion instead of tabs ... allowing for multiple sections to be opened which is useful
- change formatter to use 4 spaces instead of tab
- get some of the icons included in the layout ... used be accordion

0.1 (dkh.208):
- getting started on configuration view
0.1 (dkh.209):
- create configuration pane dummied up (with button, input, selection list)
0.1 (dkh.210):
- tweak the input algorithm for exampleText ...
0.1 (dkh.211):
- push the exampleText code to Amber-side
0.1 (dkh.212):
- tweak ...
0.1 (dkh.213):
- add footers to accordion ... '.
		spec author: 'dkh'.
		spec timestamp: '10/17/2011 20:33'.
		spec 
			project: 'Bibliocello' with: '1.0-alpha.2';
			project: 'Kaliningrad' with: '0.1';
			project: 'MetacelloBrowser' with: '1.61';
			project: 'Seaside30' with: '3.0.6';
			project: 'SeasideJSON' with: '0.1';
			project: 'JQueryWidgetBox' with: '2.4'.
		spec 
			package: 'tODE-Amber' with: 'tODE-Amber-dkh.31';
			package: 'tODE-AmberClient' with: 'tODE-AmberClient-dkh.8';
			package: 'tODE-Bibliocello' with: 'tODE-Bibliocello-dkh.12';
			package: 'tODE-Code' with: 'tODE-Code-dkh.34';
			package: 'tODE-Core' with: 'tODE-Core-dkh.71';
			package: 'tODE-Debugger' with: 'tODE-Debugger-dkh.14';
			package: 'tODE-Help' with: 'tODE-Help-dkh.2';
			package: 'tODE-Inspector' with: 'tODE-Inspector-dkh.14';
			package: 'tODE-Metacello' with: 'tODE-Metacello-dkh.69';
			package: 'tODE-Search' with: 'tODE-Search-dkh.12';
			package: 'tODE-Seaside' with: 'tODE-Seaside-dkh.59';
			package: 'tODE-TestCase' with: 'tODE-TestCase-dkh.7';
			package: 'tODE-Views' with: 'tODE-Views-dkh.44';
			package: 'tODE-Workspace' with: 'tODE-Workspace-dkh.5';
			package: 'tODE-Tests-Core' with: 'tODE-Tests-Core-dkh.7'. ].

	spec for: #'pharo' do: [
		spec 
			package: 'tODE-Pharo-Code' with: 'tODE-Pharo-Code-dkh.22';
			package: 'tODE-Pharo-Core' with: 'tODE-Pharo-Core-dkh.6';
			package: 'tODE-Pharo-Debugger' with: 'tODE-Pharo-Debugger-dkh.7';
			package: 'tODE-Pharo-Inspector' with: 'tODE-Pharo-Inspector-dkh.2';
			package: 'tODE-Pharo-Metacello' with: 'tODE-Pharo-Metacello-dkh.2';
			package: 'tODE-Pharo-Search' with: 'tODE-Pharo-Search-dkh.4';
			package: 'tODE-Pharo-Seaside' with: 'tODE-Pharo-Seaside-dkh.6';
			package: 'tODE-Pharo-Views' with: 'tODE-Pharo-Views-dkh.19';
			package: 'tODE-Pharo-Workspace' with: 'tODE-Pharo-Workspace-dkh.2'. ].

	spec for: #'gemstone' do: [
		spec 
			project: 'GsPharo' with: '0.9.1';
			project: 'WAObjectLogTable' with: '3.0.5.0.1';
			project: 'JQGrid' with: '2.4'.
		spec 
			package: 'tODE-GemStone-Code' with: 'tODE-GemStone-Code-dkh.9';
			package: 'tODE-GemStone-Core' with: 'tODE-GemStone-Core-dkh.9';
			package: 'tODE-GemStone-Debugger' with: 'tODE-GemStone-Debugger-dkh.5';
			package: 'tODE-GemStone-Inspector' with: 'tODE-GemStone-Inspector-dkh.6';
			package: 'tODE-GemStone-Search' with: 'tODE-GemStone-Search-dkh.4';
			package: 'tODE-GemStone-Seaside' with: 'tODE-GemStone-Seaside-dkh.10';
			package: 'tODE-GemStone-Views' with: 'tODE-GemStone-Views-dkh.6';
			package: 'tODE-GemTools' with: 'tODE-GemTools-dkh.10'. ].

	spec for: #'gs2.x' do: [
		spec 
			package: 'tODE-GemStone-240-Code' with: 'tODE-GemStone-240-Code-dkh.2';
			package: 'tODE-GemStone-240-Inspector' with: 'tODE-GemStone-240-Inspector-dkh.1'. ].

	spec for: #'gs3.x' do: [
		spec 
			package: 'tODE-GemStone-300-Code' with: 'tODE-GemStone-300-Code-dkh.2';
			package: 'tODE-GemStone-300-Inspector' with: 'tODE-GemStone-300-Inspector-dkh.1'. ].
! !
